/*
 * $Id: message.c,v 1.5 2004/12/30 09:07:47 ali Exp $
 * Copyright (C) 2007 J. Ali Harlow
 * Min Hack may be freely redistributed.  See license for details. 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "minhack.h"

char minhack_yn_function(const char *ques, const char *choices, char def,
  int *count)
{
    int i,x,ch,n=0,cnt=0;
    waddstr(windows[message_win].win,ques);
    if (*choices)
    {
	waddstr(windows[message_win].win," [");
	for(i=0;choices[i] && choices[i]!='\033';i++)
	    waddch(windows[message_win].win,choices[i]);
	waddstr(windows[message_win].win,"] ");
	if (def)
	{
	    char buf[5];
	    sprintf(buf,"(%c) ",def);
	    waddstr(windows[message_win].win,buf);
	}
	wclrtoeol(windows[message_win].win);
	getyx(windows[message_win].win,i,x);
	for(;;)
	{
	    ch=wgetch(windows[message_win].win);
	    switch(ch)
	    {
		case '\033':
		    if (strchr(choices,'q'))
			return 'q';
		    else if (strchr(choices,'n'))
			return 'n';
		    else
			return def;
		    break;
		case ' ':
		case '\r':
		case '\n':
		    return def;
		    break;
		default:
		    if (strchr(choices,'#') && strchr("0123456789",ch))
		    {
			waddch(windows[message_win].win,ch);
			n++;
			cnt*=10;
			cnt+=ch-'0';
		    }
		    else if (strchr(choices,ch))
		    {
			if (n)
			    *count=cnt;
			return ch;
		    }
		    else if (cnt && (ch=='\b' || ch==127))
		    {
			n--;
			wmove(windows[message_win].win,0,n+x);
			wclrtoeol(windows[message_win].win);
			cnt/=10;
		    }
		    break;
	    }
	}
    }
    else
	return wgetch(windows[message_win].win);
}

char *minhack_getlin(const char *query)
{
    int ch,n=0,x,i,j;
    static char line[80];
    nhproxy_cb_flush_screen();
    minhack_putstr(message_win,0,query);
    wclrtoeol(windows[message_win].win);
    getyx(windows[message_win].win,i,x);
    for(;;)
    {
	ch=wgetch(windows[message_win].win);
	if (ch>=' ' && ch<='~' && n<sizeof(line)-1)
	{
	    waddch(windows[message_win].win,ch);
	    line[n++]=ch;
	}
	else if (n && (ch=='\b' || ch==127))
	{
	    n--;
	    wmove(windows[message_win].win,0,n+x);
	    wclrtoeol(windows[message_win].win);
	}
	else if (ch=='\n' || ch=='\r')
	{
	    line[n]='\0';
	    return line;
	}
	else if (ch=='\033')
	{
	    line[0]='\033';
	    line[1]='\0';
	    return line;
	}
    }
}

int minhack_get_ext_cmd(void)
{
    int i,cmd=-1;
    char *line;
    struct nhproxy_cb_get_extended_commands_res *commands;
    commands=nhproxy_cb_get_extended_commands();
    line=minhack_getlin("# ");
    for(i=0;i<commands->n_commands;i++)
	if (!strcmp(commands->commands[i],line))
	{
	    cmd=i;
	    break;
	}
    nhproxy_cb_free_extended_commands(commands);
    return cmd;
}
